/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"


#include <stdio.h>
#include <string.h> /* strstr() */
#include <stdlib.h>                         /* free() exit() */
#include "../../src/initng_handler.h"
#include "../../src/initng_global.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_common.h"
#include "../../src/initng_toolbox.h"

#include "initng_interactive.h"



/* Ask for every service if it shud start */
void check_interactive(active_h * service)
{
    char asw[10];
    asw[0]='\0';
    if(service->a_status!=START_DEP_MET) return;

    printf("Start service %s, (Y/n):", service->name);
    fgets(asw, 9, stdin);
    if(asw[0]!='y' && asw[0]!='Y' && (strstr(asw, "yes")==NULL))
	mark_service(service, FAIL_STARTING);
    return;
}


int module_init(void)
{
    int i;
    D_("module_init();\n");
    for(i=0; g.Argv[i]; i++)
	if(strstr(g.Argv[i], "--interactive")) {
	    printf("Initng is started in interactive mode!\n");
	    initng_add_hook(WATCHERS, &check_interactive);
	    return(TRUE);
	}

    return (TRUE);
}

void module_unload(void)
{
    D_("module_unload();\n");
    initng_del_hook(WATCHERS, &check_interactive);
}
